(function() {
	'use strict';
	var $, HoverIcon;

	$ = jQuery;

	HoverIcon = (function() {

		function HoverIcon(widget, parent) {
			Widget.apply(this, arguments);

			var icon = this.widget.icon
					|| '/static/images/managecenter/example/hovericon.png';

			this.$widget = $('<div class="hover-icon"></div>');
			this.$icon = $('<img />').attr('src', icon);
			this.$widget.append(this.$icon);

			this.widget.top && this.$widget.css('top', this.widget.top);

			return this;
		}

		HoverIcon.prototype.init = function() {
			$('.hover-icon').remove();
			this.$panel.append(this.$widget);
			return this;
		};

		HoverIcon.prototype.exportWidget = function() {
			return this.widget;
		};

		HoverIcon.prototype.performClick = function() {
			if (this.widget.link) {
				FXUI.goPage(this.widget.link);
			}
		};

		HoverIcon.prototype.draggingBegan = function() {
			this.parent.removeDropContainer();
		};

		HoverIcon.prototype.draggingEnded = function() {
			if (this.frame().left > $(window).width() / 2) {
				this.$widget.css('left', 'unset').css('right', '.1rem');
			}
			if (this.frame().left < $(window).width() / 2) {
				this.$widget.css('left', '.1rem');
			}
			this.widget.top = this.$widget.position().top;
		};

		HoverIcon.prototype.draggingMoved = function() {
			var w = this.$widget.width();
			var h = this.$widget.height();
			if (this.frame().left + w > $(window).width()) {
				this.$widget.css('left', 'unset').css('right', '.1rem');
			}
			if (this.frame().left < 0) {
				this.$widget.css('left', '.1rem');
			}
			if (this.frame().top + h / 2 > $(window).height()) {
				this.$widget.css('top', $(window).height() - h / 2);
			}

			if (this.frame().top - h / 2 < 0) {
				this.$widget.css('top', h / 2);
			}
		};

		HoverIcon.prototype.trash = function() {
			this.parent.subWidgets.splice(this.getIndex(), 1);
			this.$widget.remove();
		};

		HoverIcon.prototype.frame = function() {
			return {
				$widget : this.$widget,
				top : this.$widget.position().top,
				left : this.$widget.position().left,
				width : this.width,
				height : this.height
			};
		};

		return HoverIcon;

	})();

	Widget.register('HoverIcon', HoverIcon);

}).call(this);