(function() {
	'use strict';
	var $, Iframe;

	$ = jQuery;

	Iframe = (function() {

		Iframe.description = {
			name : 'Iframe',
			desc : 'Iframe',
			icon : ''
		};

		function Iframe(widget, parent) {
			Widget.apply(this, arguments);

			this.settings = this.widget.settings || {};
			this.width = this.window().width;
			this.height = this.window().height - $('#header').height() - $('#footer').height();
			this.servers = this.widget.servers || [];
			
			if (this.servers.length == 0) {
				this.servers.push({
					serverId : Portal.app.serverId,
					serverType : Portal.app.taxType,
					serverUrl : Portal.server.gsServerUrl
				});
			}
			Widget.storage['serverUrl'] = this.servers[0].serverUrl;

			this.$iframe = null;
			this.$widget = $('<div></div>').addClass('iframe loading').css({
				width : this.width,
				height : this.height
			});
			this.$header = $('#header');
			this.$footer = $('#footer');
			this.$iframeContainer = $('#tabcontent_container');

			return this;
		}

		Iframe.prototype.init = function() {
			if (!this.parent) {
				this.$header.hide();
				this.$footer.hide();
				this.$iframeContainer.closest('.content').css('top', 0);
				this.height = this.window().height;
				$('.content').css('overflow', 'hidden');
				this.$iframeContainer.empty().append(this.$widget);
				this.show();
			} else {
				this.parent.$widget.append(this.$widget);
			}
			return this;
		};

		Iframe.prototype.exportWidget = function() {
			this.widget.widgets = [];
			this.settings.height = this.height;
			this.widget.settings = this.settings;
			return this.widget;
		};

		Iframe.prototype.show = function() {
			var that = this;
			if (this.parent && this.parent.parent.headerHidden) {
				this.height = this.window().height - $('#footer').height();
			}
			this.$widget.css({
				width : this.width,
				height : this.height
			});
			if (this.$iframe == null) {
				var url = this.widget.url;
				url && (url += (url.indexOf('?') > 0 ? '&' : '?') + 'time=' + Date.now());
				this.$iframe = $('<iframe></iframe>').attr({
					name : this.id,
					frameborder : '0',
					width : this.width,
					height : this.height,
					scrolling : 'no',
					src : url
				}).load(function() {
					that.$widget.removeClass('loading');
				});
			}
			if ($('iframe[name="' + this.id + '"]')[0] == undefined) {
				this.$widget.append(this.$iframe);
			}
		};
		
		Iframe.prototype.hide = function() {
			if (Portal.platformType == '02' && this.$iframe) {
				this.$iframe.detach();
			}
		};

		Iframe.prototype.frame = function() {
			return {
				$widget : this.$widget,
				top : this.$widget.position().top,
				left : this.$widget.position().left,
				width : this.width,
				height : this.height
			};
		};

		return Iframe;

	})();

	Widget.register('Iframe', Iframe);

}).call(this);