(function() {
	'use strict';
	var $, Link;

	$ = jQuery;

	Link = (function() {

		Link.userType = {
			tourist : '01',
			login : '02',
			enterprise : '03',
			individual : '04'
		};

		function Link(widget, parent) {
			Widget.apply(this, arguments);

			this.settings = this.widget.settings || {};
			this.url = this.settings.url || '';
			this.backPage = this.settings.backPage || '';
			this.servers = this.widget.servers || [];
			this.userType = widget.userType || '01';
			
			if (this.servers.length == 0) {
				var serverId = this.widget.serverId || Portal.app.serverId;
				var serverType = '1';
				var serverUrl = Portal.server.gsServerUrl;
				this.servers.push({
					serverId : serverId,
					serverType : serverType,
					serverUrl : serverUrl
				});
			}

			return this;
		}

		Link.prototype.init = function() {
			// 以接入点第一个为准
			$.showIndicator();
			Widget.storage['serverUrl'] = this.servers[0].serverUrl;
			Widget.storage[Portal.appId + '_' + Portal.platformType + '_page'] = this.backPage || Portal.page;
			var url = this.url;
			try {
				eval(url);
				return;
			} catch(e) {
			}
			var prefix = '';
			if (url.indexOf('#') > 0 && url.indexOf('/#/') < 0) {
				prefix = url.substring(url.indexOf('#'), url.length);
				url = url.substring(0, url.indexOf('#'));
			}
			if (url.indexOf('?') > 0) {
				url += '&gdslxdm=' + this.servers[0].serverType;
			} else {
				url += '?gdslxdm=' + this.servers[0].serverType;
			}
			url += document.location.search ? ('&' + document.location.search.substr(1)) : '';
			url += prefix;

			var goLogin = function() {
				$.toast('请先登录！');
				setTimeout(function() {
					// FXUI.goPage('/app/assets/user/login.html?redirectUrl=' + encodeURIComponent(url));
					var redirectUrl = '/app/assets/user/redirect.html?redirectUrl=' + encodeURIComponent(url);
					window.location.replace('/app/assets/user/login.html?redirectUrl=' + encodeURIComponent(redirectUrl));
				}, 800);
			};
			
			var pushSessionCallback = function(push, serverId, sessionName, sessionId) {
				goRedirect(push, sessionName, sessionId, url);
			};

			var a = this;
			var pushSession = function(servers) {
				var server = servers.pop();
				if (servers.length == 0) {
					FXUI.pushSessionToBizfront(pushSessionCallback, server.serverId, server.serverType);
				} else {
					FXUI.pushSessionToBizfront(function() {
						pushSession(servers);
					}, server.serverId, server.serverType);
				}
			};

			var goRedirect = function(push, sessionName, sessionId, url) {
				if (push && /iPhone/.test(navigator.userAgent)) {
					// FXUI.goPage(Widget.storage['serverUrl'] + '/session/redirect.do?' + sessionName + '=' + sessionId + '&redirectUrl=' + encodeURIComponent(url));
					window.location.replace(Widget.storage['serverUrl'] + '/session/redirect.do?' + sessionName + '=' + sessionId + '&redirectUrl=' + encodeURIComponent(url));
				} else {
					// FXUI.goPage(url);
					window.location.replace(url);
				}
			};

			switch (this.userType) {
			case Link.userType.tourist:
				pushSession(a.servers);
				break;
			case Link.userType.login:
				if (Portal.userDetails != null) {
					pushSession(a.servers);
				} else {
					goLogin();
				}
				break;
			case Link.userType.enterprise:
				if (Portal.userDetails != null) {
					if (Portal.userDetails.nsr != null) {
						pushSession(a.servers);
					} else {
						if (Portal.userDetails.userNsrs != null && Portal.userDetails.userNsrs.length > 0) {
							$.toast('请先切换为企业纳税人身份！');
							setTimeout(function() {
								// FXUI.goPage('/app/assets/user/role.html?redirectUrl=' + encodeURIComponent(window.location.href));
								window.location.replace('/app/assets/user/role.html?redirectUrl=' + encodeURIComponent(window.location.href));
							}, 800);
						} else {
							$.toast('您尚未绑定纳税人，请先绑定纳税人！');
							setTimeout(function() {
								// FXUI.goPage('/app/assets/user/bdnsr.html?redirectUrl=' + encodeURIComponent(window.location.href));
								window.location.replace('/app/assets/user/bdnsr.html?redirectUrl=' + encodeURIComponent(window.location.href));
							}, 800);
						}
					}
				} else {
					goLogin();
				}
				break;
			case Link.userType.individual:
				if (Portal.userDetails != null) {
					if (Portal.userDetails.zrr != null) {
						pushSession(a.servers);
					} else {
						$.toast('您尚未实名认证，请先实名认证！');
						setTimeout(function() {
							// FXUI.goPage('/app/assets/user/smzxx.html?redirectUrl=' + encodeURIComponent(window.location.href));
							window.location.replace('/app/assets/user/smzxx.html?redirectUrl=' + encodeURIComponent(window.location.href));
						}, 800);
					}
				} else {
					goLogin();
				}
				break;
			default:
				// FXUI.goPage(url);
				window.location.replace(url);
				break;
			}
			return this;
		};

		Link.prototype.exportWidget = function() {
			this.widget.widgets = [];
			return this.widget;
		};

		Link.prototype.frame = function() {

		};
		
		Link.prototype.resize = function() {

		};

		return Link;

	})();

	Widget.register('Link', Link);

}).call(this);