(function() {
	'use strict';

	var ls = {
		set : function(key, value) {
			localStorage.setItem(key, value);
		},
		get : function(key) {
			return localStorage.getItem(key);
		},
		remove : function(key) {
			localStorage.removeItem(key);
		}
	};

	function load(script) {
		if (!script.isDebug) {
			var localJs = ls.get(script.lsKey);
			if (localJs) {
				insertScript(localJs, script.after);
			} else {
				loadFormUrl(script);
			}
		} else {
			loadFormUrl(script);
		}
	}

	function loadFormUrl(script) {
		var success = function(js) {
			if (script.lsPrefix) {
				for (var i = 0; i < localStorage.length; i++) {
					var k = localStorage.key(i);
					if (k.indexOf(script.lsPrefix) == 0) {
						ls.remove(k);
					}
				}
			}
			ls.set(script.lsKey, js);
			insertScript(js, script.after);
		};
		var error = function() {
			throw 'Load failed: ' + script.url;
		};
		requestJS(script.url, success, error);
	}

	function insertScript(scriptText, after) {
		if (scriptText) {
			var head = document.getElementsByTagName('head')[0];
			var script = document.createElement('script');
			script.appendChild(document.createTextNode(scriptText));
			head && head.appendChild(script);
			isFunction(after) && after.call(this, {});
		}
	}

	function requestJS(url, success, error) {
		var request;
		var method = 'GET';
		var complete = function() {
			request.status == 200 ? success(request.responseText) : error();
		};
		request = new XMLHttpRequest;
		request.open(method, url, false);
		request.onload = complete;
		request.onerror = error;
		request.ontimeout = error;
		request.send();
	}

	function isFunction(fun) {
		return 'function' == typeof fun;
	}

	var script = {
		url : '/static/js/assets/portal.min.js',
		lsPrefix : 'PORTAL_CORE_',
		lsKey : 'PORTAL_CORE_201907110958',
		isDebug : false,
		after : function() {

		}
	};
	load(script);
}).call(this);
