(function() {
	'use strict';
	var $, MenuItem;

	$ = jQuery;

	MenuItem = (function() {

		MenuItem.example = {
			name : 'MenuItem',
			title : '菜单名称',
			icon : '/static/images/common/menuitem.png'
		};

		function MenuItem(widget, parent) {
			Widget.apply(this, arguments);
			
			this.subWidgets = [];

			this.$widget = $('<td class="row-item"></td>').attr('id', this.id);
			this.$icon = $('<div class="icon"></div>');
			this.$title = $('<a></a>').html(this.widget.title);
			this.$badge = $('<span>12</span>').addClass('badge');
			this.$widget.append(this.$icon).append(this.$title);

			this.userType = widget.userType || '01';
			this.serverId = this.widget.serverId || Portal.app.serverId;
			this.serverType = '1';
			this.serverUrl = this.widget.serverUrl || Portal.server.gsServerUrl;

			return this;
		}

		MenuItem.prototype.init = function() {
			var self = this;
			this.parent.$tr.append(this.$widget);
			this.$widget.click(function(event) {
				event.preventDefault();
				event.stopPropagation();
				self.open();
			});
			return this;
		};

		MenuItem.prototype.exportWidget = function() {
			return this.widget;
		};

		MenuItem.prototype.show = function() {
			if (this.widget.icon && !this.imgLoaded) {
				this.$icon.append($('<img/>').attr('src', this.widget.icon));
				this.showBadge();
				this.imgLoaded = true;
			}
		};

		MenuItem.prototype.setTitleWidth = function(width) {
			this.$title.width(width);
		};

		MenuItem.prototype.open = function() {
			Portal.goPage({
				uuid : this.widget.uuid,
				url : this.widget.url,
				serverId : this.serverId,
				serverUrl : this.serverUrl,
				serverType : this.serverType,
				userType : this.userType,
				redirectTips : this.widget.redirectTips,
                blankTips : this.widget.blankTips,
				confirmText : this.widget.confirmText,
                title : this.widget.title
			});
		};

		MenuItem.prototype.showBadge = function() {
			var a = this;
			var url = this.widget.badgeUrl;
			if (!url) {
				return;
			}
			var callback = function(d) {
				if (d.number && d.number > 0) {
					a.$badge.html(d.number > 99 ? 99 : d.number);
					a.$widget.append(a.$badge);
				}
			};
			FXUI.post(url, {}, callback);
		};

		return MenuItem;

	})();

	Widget.register('MenuItem', MenuItem);

}).call(this);