(function() {
	'use strict';
	var $, MenuList;

	$ = jQuery;

	MenuList = (function() {

		MenuList.description = {
			name : 'MenuList',
			desc : '菜单列表'
		};

		function MenuList(widget, parent) {
			Widget.apply(this, arguments);
			
			this.subWidgets = [];

			this.$widget = $('<div class="menu-list"></div>').attr('id', this.id);
			this.$ul = $('<ul></ul>');
			this.$widget.append(this.$ul);

			return this;
		}

		MenuList.prototype.init = function() {
			this.parent.$widget.append(this.$widget);
			return this;
		};

		MenuList.prototype.addSubWidget = function(widget) {
			this.subWidgets.push(widget);
		};

		MenuList.prototype.exportWidget = function() {
			this.widget.widgets = [];
			for (var i = 0; i < this.subWidgets.length; i++) {
				this.subWidgets[i].exportWidget && this.widget.widgets.push(this.subWidgets[i].exportWidget());
			}
			return this.widget;
		};

		MenuList.prototype.show = function() {
			for (var i = 0, j = this.subWidgets.length; i < j; i++) {
				this.subWidgets[i].show();
			}
		};

		MenuList.prototype.layout = function() {
			this.parent.layout();
		};

		MenuList.prototype.resize = function() {
			for (var i = 0, j = this.subWidgets.length; i < j; i++) {
				this.subWidgets[i].resize();
			}
		};

		MenuList.prototype.frame = function() {
			return {
				$widget : this.$widget,
				top : this.$widget.position().top,
				left : this.$widget.position().left,
				width : this.width,
				height : this.$widget.outerHeight(true)
			};
		};

		return MenuList;

	})();

	Widget.register('MenuList', MenuList);

}).call(this);