(function() {
	'use strict';
	var $, MenuListItem;

	$ = jQuery;

	MenuListItem = (function() {

		function MenuListItem(widget, parent) {
			Widget.apply(this, arguments);
			
			this.width = this.window().width;

			this.$widget = $('<li class="menu-list-item"></li>').attr('id', this.id);
			this.$icon = $('<div class="icon"></div>');
			this.$title = $('<a></a>').html(this.widget.title);
			this.$badge = $('<span>12</span>').addClass('badge');
			this.$widget.append(this.$icon).append(this.$title);

			this.init = function() {
				var self = this;
				this.parent.$ul.append(this.$widget);
				this.$widget.click(function(event) {
					event.preventDefault();
					event.stopPropagation();
					self.open();
				});
				this.layout();
				return this;
			};
			
			this.exportWidget = function() {
				return this.widget;
			};

			this.show = function() {
				if (this.widget.icon && !this.imgLoaded) {
					this.$icon.append($('<img/>').attr('src', this.widget.icon));
					this.showBadge();
					this.imgLoaded = true;
				}
			};

			this.layout = function() {
				var pl = parseInt(this.$title.css('padding-left'));
				var pr = parseInt(this.$title.css('padding-right'));
				if (pl && pr) {
					this.$title.width($(window).width() - pl - pr);
				}
			};

			this.open = function() {
				if (this.widget.login && Portal.userDetails == null) {
					$.toast('请先登录！');
					setTimeout(function() {
						FXUI.goPage('/app/assets/user/login.html?FxAppId=' + Portal.appId + '&page=' + Portal.page);
					}, 500);
					return;
				}
				if (this.widget.blankTips) {
					$.toast(this.widget.blankTips);
					return;
				}
				this.widget.url && FXUI.goPage(this.widget.url);
			};

			this.showBadge = function() {
				var a = this;
				var url = this.widget.badgeUrl;
				if (!url) {
					return;
				}
				var callback = function(d) {
					if (d.number && d.number > 0) {
						a.$badge.html(d.number > 99 ? 99 : d.number);
						a.$widget.append(a.$badge);
					}
				};
				FXUI.post(url, {}, callback);
			};

			this.resize = function() {
				this.layout();
			};

			this.frame = function() {
				return {
					$widget : this.$widget,
					top : this.$widget.position().top,
					left : this.$widget.position().left,
					width : this.width,
					height : this.$widget.height()
				};
			};

			return this;
		}

		return MenuListItem;

	})();

	Widget.register('MenuListItem', MenuListItem);

}).call(this);