(function() {
	'use strict';
	var $, MenuRow;

	$ = jQuery;

	MenuRow = (function() {

		MenuRow.example = {
			name : 'MenuRow'
		};

		function MenuRow(widget, parent) {
			Widget.apply(this, arguments);
			
			this.subWidgets = [];
			this.width = this.window().width;

			this.$widget = $('<div class="block-row"></div>').attr('id', this.id);
			this.$table = $('<table width="100%" border="0" cellspacing="0" cellpadding="0"></table>');
			this.$tr = $('<tr></tr>').appendTo(this.$table);
			this.$widget.append(this.$table);
			
			return this;
		}

		MenuRow.prototype.init = function() {
			this.parent.$body.append(this.$widget);
			this.layout();
			return this;
		};
		
		MenuRow.prototype.addSubWidget = function(widget) {
			this.subWidgets.push(widget);
		};
		
		MenuRow.prototype.exportWidget = function() {
			this.widget.widgets = [];
			for (var i = 0; i < this.subWidgets.length; i++) {
				this.subWidgets[i].exportWidget && this.widget.widgets.push(this.subWidgets[i].exportWidget());
			}
			return this.widget;
		};

		MenuRow.prototype.show = function() {
			for (var i = 0, j = this.subWidgets.length; i < j; i++) {
				this.subWidgets[i].show();
			}
		};

		MenuRow.prototype.layout = function() {
			if (this.subWidgets.length > 1) {
				var w = 100 / this.subWidgets.length;
				var rw = this.width / this.subWidgets.length;
				for (var i in this.subWidgets) {
					this.subWidgets[i].$widget.css('width', w + '%');
					this.subWidgets[i].setTitleWidth(rw);
				}
			} else if (this.subWidgets.length == 1) {
				this.subWidgets[0].$widget.css('width', '100%');
				this.subWidgets[0].setTitleWidth(this.width);
			}
		};

		MenuRow.prototype.frame = function() {
			return {
				$widget : this.$widget,
				top : this.$widget.position().top,
				left : this.$widget.position().left,
				width : this.width,
				height : this.$widget.height()
			};
		};

		return MenuRow;

	})();

	Widget.register('MenuRow', MenuRow);

}).call(this);