(function() {
	'use strict';
	var $, Notice;

	$ = jQuery;

	Notice = (function() {

		function Notice(widget, parent) {
			Widget.apply(this, arguments);

			this.width = this.window().width;

			this.$widget = $('<div class="notice"></div>').attr('id', this.id);
			this.$icon = $('<span class="icon2-notice2"></span>');
			this.$inner = $('<div class="notice-inner"></div>');
			this.$widget.append(this.$icon).append(this.$inner);
			
			return this;
		}

		Notice.prototype.init = function() {
			this.parent.$widget.append(this.$widget);
			this.getData();
			return this;
		};

		Notice.prototype.exportWidget = function() {
			return this.widget;
		};

		Notice.prototype.getData = function() {
			if (!this.widget.dataUrl || !this.widget.dataItem) {
				return;
			}
			var that = this;
			var callback = function(d) {
				try {
					var datas = eval(that.widget.dataItem.substr(0, that.widget.dataItem.indexOf('[')));
					if (!datas || datas.length == 0) {
						that.remove();
						return;
					}
					for (var i = 0, j = datas.length; i < j; i++) {
						var title = eval(that.widget.dataItem);
						var $item = $('<div class="notice-item"></div>');
						$item.append($('<span class="notice-title"></span>').append(title));
						if (i === 0) {
							$item.append($('<span class="icon2-noticenew"></span>'));
						}
						that.$inner.append($item);
					}
					that.setCarousel(datas.length);
					that.$widget.click(function() {
						if (that.widget.openUrl) {
							FXUI.goPage(that.widget.openUrl);
						}
					});
				} catch (e) {
					that.remove();
				}
			};
			var errorCallback = function() {
				that.remove();
			};
			FXUI.post(this.widget.dataUrl, {}, callback, '', errorCallback);
		};

		Notice.prototype.setCarousel = function(length) {
			if (length <= 1) {
				return;
			}
			var carousel = this.$inner.carousel({
				wrap : false,
				vertical : true,
				horizontal : false
			});
			var index = 0;
			setInterval(function() {
				index++;
				if (index >= length) {
					index = 0;
				}
				carousel.onMoveIndex(index);
			}, 5000);
		};

		Notice.prototype.remove = function() {
			this.$widget.next('.w-margin').remove();
			this.$widget.remove();
		};

		Notice.prototype.frame = function() {
			return {
				$widget : this.$widget,
				top : this.$widget.position().top,
				left : this.$widget.position().left,
				width : this.width,
				height : this.$widget.height()
			};
		};

		return Notice;

	})();

	Widget.register('Notice', Notice);

}).call(this);