(function() {
	'use strict';
	var $, RoleNav;

	$ = jQuery;

	RoleNav = (function() {

		RoleNav.description = {
			name : 'RoleNav',
			desc : '角色导航条'
		};

		function RoleNav(widget, parent) {
			Widget.apply(this, arguments);

			this.$widget = $('<div class="rolenav"></div>');
			this.$header = $('#header').removeClass('mp-header');
			this.$h = $('<h1></h1>').html(this.parent.widget.title);
			this.$role = $('<p class="role-change">身份切换<p>');
			this.$name = $('<p class="role-name"></p>');

			return this;
		}

		RoleNav.prototype.init = function() {
			return this;
		};

		RoleNav.prototype.exportWidget = function() {
			return this.widget;
		};

		RoleNav.prototype.show = function() {
			this.setHeader();
			this.$header.addClass('rolenav-header');
			this.$h.html(this.parent.widget.title);
			this.$header.empty().append(this.$h);
			this.setLoginUser();
			var self = this;
			Portal.loadCallback(function() {
				self.setLoginUser();
			});
		};

		RoleNav.prototype.hide = function() {
			this.$header.removeClass('rolenav-header');
		};

		RoleNav.prototype.setLoginUser = function() {
			if (Portal.userDetails && Portal.userDetails.user) {
				var name = Portal.userDetails.user.xm;
				Portal.userDetails.zrr && (name = Portal.userDetails.zrr.xm);
				Portal.userDetails.nsr && (name = Portal.userDetails.nsr.nsrmc || Portal.userDetails.nsr.dsNsrmc);
				this.$name.html(name);
				this.$header.append(this.$role).append(this.$name);
				var self = this;
				var toRole = function() {
					if (self.widget.roleUrl) {
						FXUI.goPage(self.widget.roleUrl);
					} else {
						FXUI.goPage('/app/assets/user/role.html');
					}
				};
				this.$role.on('click', toRole);
				this.$name.on('click', toRole);
				var name = this.$name[0];
				setInterval(function() {
					if (name.scrollWidth - name.scrollLeft <= name.offsetWidth) {
						name.scrollLeft -= name.scrollWidth;
					} else {
						name.scrollLeft++;
					}
				}, 200);
			}
		};

		RoleNav.prototype.setHeader = function() {
			if (this.widget.headerHidden === true) {
				this.$header.hide();
				$('#content').css('top', 0);
			} else {
				this.$header.show();
				$('#content').css('top', '2.2rem');
			}
		};

		RoleNav.prototype.frame = function() {
			return {
				$widget : this.$widget,
				top : this.$widget.position().top,
				left : this.$widget.position().left,
				width : this.width,
				height : this.height
			};
		};

		return RoleNav;

	})();

	Widget.register('RoleNav', RoleNav);

}).call(this);