(function() {
	'use strict';
	var $, Text;

	$ = jQuery;

	Text = (function() {

		Text.description = {
			name : 'Text',
			desc : '文本',
			icon : ''
		};

		function Text(widget, parent) {
			Widget.apply(this, arguments);

			this.width = this.window().width;
			this.height = 40;

			this.$widget = $('<div></div>').attr('id', this.id)
					.addClass('text');
			this.$widget.html(this.widget.text);

			this.style = widget.style || {};
			this.style.fontColor = this.style.fontColor || '#333';
			this.style.fontSize = this.style.fontSize || 12;
			this.style.width = this.width;
			this.style.height = this.style.height || this.height;
			this.style.textAlign = this.style.textAlign || 'center';

			return this;
		}

		Text.prototype.init = function() {
			this.parent.$widget.append(this.$widget);
			this.setStyle();
			return this;
		};

		Text.prototype.exportWidget = function() {
			this.widget.widgets = [];
			this.widget.style = this.style;
			return this.widget;
		};

		Text.prototype.setStyle = function(key, value) {
			if (key && value) {
				this.style[key] = value;
			}
			this.$widget.css('width', this.style.width + 'px');
			this.$widget.css('height', this.style.height + 'px');
			this.$widget.css('line-height', this.style.height + 'px');
			this.$widget.css('color', this.style.fontColor);
			this.$widget.css('font-size', this.style.fontSize + 'px');
			this.$widget.css('text-align', this.style.textAlign);

			this.height = this.style.height;
		};

		Text.prototype.frame = function() {
			return {
				$widget : this.$widget,
				top : this.$widget.position().top,
				left : this.$widget.position().left,
				width : this.width,
				height : this.height
			};
		};

		Text.prototype.resize = function() {
			this.width = this.window().width;
			this.style.width = this.width;
			this.setStyle();
		};

		return Text;

	})();

	Widget.register('Text', Text);

}).call(this);