(function() {
	'use strict';
	var $, TitleNav;

	$ = jQuery;

	TitleNav = (function() {

		TitleNav.description = {
			name : 'TitleNav',
			desc : '标题导航条'
		};

		function TitleNav(widget, parent) {
			Widget.apply(this, arguments);

			this.$widget = $('<div class="titlenav"></div>');
			this.$header = $('#header').removeClass('mp-header');
			this.$h = $('<h1></h1>').html(this.parent.widget.title);

			return this;
		}

		TitleNav.prototype.init = function() {
			return this;
		};

		TitleNav.prototype.exportWidget = function() {
			return this.widget;
		};

		TitleNav.prototype.show = function() {
			this.setHeader();
			this.$h.html(this.parent.widget.title);
			this.$header.empty().append(this.$h);
		};

		TitleNav.prototype.hide = function() {
			
		};

		TitleNav.prototype.setHeader = function() {
			if (this.widget.headerHidden === true) {
				this.$header.hide();
				$('#content').css('top', 0);
			} else {
				this.$header.show();
				$('#content').css('top', '2.2rem');
			}
		};

		TitleNav.prototype.frame = function() {
			return {
				$widget : this.$widget,
				top : this.$widget.position().top,
				left : this.$widget.position().left,
				width : this.width,
				height : this.height
			};
		};

		return TitleNav;

	})();

	Widget.register('TitleNav', TitleNav);

}).call(this);