(function() {
	'use strict';
	var $, UserNav, storage = window.localStorage;

	$ = jQuery;

	UserNav = (function() {

		UserNav.description = {
			name : 'UserNav',
			desc : '用户导航条'
		};

		function UserNav(widget, parent) {
			Widget.apply(this, arguments);

			this.titleSize = 0.8;

			this.$widget = $('<div class="usernav"><div class="bg"></div></div>');
			this.$header = $('#header').removeClass('mp-header');
			this.$userInfoWrapper = $('<div class="user-info-w"></div>').appendTo(this.$widget);
			this.$userInfo = $('<div class="user-info arrow"></div>').appendTo(this.$userInfoWrapper);
			this.$userHead = $('<div class="user-img"><img src="/static/images/common/head2.png"/></div>');
			this.$userHeadUpload = $('<input type="file" name="file" accept="image/*" multiple>');
			this.$center = $('<div class="user-center"></div>');
			this.$title = $('<div class="app-title"></div>').html(this.resolveTitle(this.widget.title));
			this.$loginWrapper = $('<div class="login-wrapper"></div>');
			this.$login = $('<span class="icon2-login2"></span>');
			this.$loginBtn = $('<a>未登录</a>');
			this.$loginWrapper.append(this.$login).append(this.$loginBtn);
			this.$center.append(this.$title).append(this.$loginWrapper);
			this.$userInfo.append(this.$userHead).append(this.$center);

			this.style = widget.style || {};
			this.style.titleSize = this.style.titleSize || 1;

			return this;
		}

		UserNav.prototype.init = function() {
			return this;
		};

		UserNav.prototype.exportWidget = function() {
			this.widget.style = this.style;
			return this.widget;
		};

		UserNav.prototype.show = function() {
			this.$panel.addClass('usernav-panel');
			this.$header.show().empty().append(this.$widget);
			this.setStyle();
			this.setLoginUser();
			var self = this;
			Portal.loadCallback(function() {
				self.setLoginUser();
			});
		};

		UserNav.prototype.hide = function() {
			this.$panel.removeClass('usernav-panel');
		};

		UserNav.prototype.resolveTitle = function(title) {
			if (title && title.indexOf('#') > 0) {
				var titles = title.split('#');
				title = '<p>' + titles[0] + '</p>' + '<p>' + titles[1] + '</p>';
			}
			return title;
		};

		UserNav.prototype.setStyle = function(key, value) {
			if (key && value) {
				this.style[key] = value;
			}
			this.$title.css({'fontSize' : (this.titleSize * this.style.titleSize) + 'rem'});
		};

		UserNav.prototype.setLoginUser = function() {
			if (Portal.userDetails && Portal.userDetails.user) {
				var url;
				(url = Portal.userDetails.user.yhtxdz) && this.setUserHead(url);
				var name = Portal.userDetails.user.xm || Portal.userDetails.user.yhm;
				Portal.userDetails.zrr && (name = Portal.userDetails.zrr.xm);
				Portal.userDetails.nsr && (name = Portal.userDetails.nsr.nsrmc || Portal.userDetails.nsr.dsNsrmc);
				this.$loginBtn.html(name);
				this.resize();

				var self = this;
				this.$userInfo.on('click', function(event) {
					if (event.target.tagName === 'INPUT') {
						return;
					}
					self.widget.link && FXUI.goPage(self.widget.link);
				});
				this.setUserHeadUpload();
			} else {
				this.$loginBtn.html('未登录');
				this.$userInfo.on('click', function() {
					FXUI.goPage('/app/assets/user/login.html?FxAppId=' + Portal.appId + '&page=' + Portal.page);
				});
			}
		};

		UserNav.prototype.setUserHead = function(url) {
			if (url.indexOf('http') < 0 && url.indexOf('/appres') < 0) {
				url = '/appres' + url;
			}
			$('img', this.$userHead).attr('src', url);
		};
		
		UserNav.prototype.setUserHeadUpload = function() {
			if (this.isSetUserHeadUpload || FXUI.isWx()) {
				return;
			}
			var self = this;
			this.$userHead.append(this.$userHeadUpload);
			loadScript(['/static/libs/jquery/vendor/jquery.ui.widget.js', '/static/libs/jquery/jquery.fileupload.js'], function() {
				self.$userHeadUpload.fileupload({
					url : '/app/cgi/attachment/upload.do?basePath=/userheads',
					send : function(e, data) {
						self.$userHead.addClass('disabled');
					},
					done : function(e, data) {
						var result = data.result;
						if (result.flag == 'error') {
							$.toast(result.errMsg);
							self.$userHead.removeClass('disabled');
						} else {
							FXUI.post('/app/user/setHeadImg.do', {
								path : result.path
							}, function(data) {
								if (data.flag == 'error') {
									$.toast(data.errMsg);
								} else {
									self.setUserHead(result.path);
								}
								self.$userHead.removeClass('disabled');
							});
						}
					},
			        fail : function(e, data) {
			        		$.toast('上传失败:' + data.jqXHR.responseJSON.error);
			        		self.$userHead.removeClass('disabled');
			        }
				});
			});
			this.isSetUserHeadUpload = true;
		};
		
		UserNav.prototype.resize = function() {
			var nw = this.$userInfo.width() - this.$userHead.width() - this.$login.width() - this.$userHead.position().left * 3 - 10;
			this.$loginBtn.width(nw);
		};

		UserNav.prototype.frame = function() {
			return {
				$widget : this.$widget,
				top : this.$widget.position().top,
				left : this.$widget.position().left,
				width : this.width,
				height : this.height
			};
		};

		return UserNav;

	})();

	Widget.register('UserNav', UserNav);

}).call(this);