+(function($) {
	'use strict';
	var FXUI = function(opts){
		// 预留可配置能力
		this.init();
	};
	FXUI.prototype = {
		IsWxConfig:false,
		// 以下参数用于回调页面使用
		Queue : [],
		Task : {
			id : 0,
			callback : function() {
			},
			errorCallback : function() {
			},
			init : function(id, callback, errorCallback) {
				this.id = id;
				this.callback = callback;
				this.errorCallback = errorCallback;
				return this;
			}
		},
		onSuccess : function(id, d) {
			try {
				top.FXUI.Queue[id].callback(d);
			} catch (e) {
			}
		},
		onError : function(id, d) {
			try {
				top.FXUI.Queue[id].errorCallback(d);
			} catch (e) {
			}
		},
		/**
		 * 增加任务以便回调使用
		 * @param success
		 * @param fail
		 * @returns 任务序号
		 */
		addTask : function(success, fail){
			top.FXUI.Queue.push(this.Task.init(this.Queue.length, success, fail));
			return top.FXUI.Queue.length - 1;
		},
		init : function(){
			//加载移动端ui主框架light7
			this.requireComponent("cola-ui");
		},
		/**
		 * 加载指定ui组件
		 * @param name 组件名称，当前可选组件为"light7"、"vue"、"swiper"、"cityPicker"、"swipeout","fileupload","ajaxFileUpload"
		 */
		requireComponent : function(name){
			switch(name)
			{
				case "cola-ui"://移动端ui主框架，必须引用
					this.require("/static/libs/cola-ui/semantic.min.css","css");
					this.require("/static/libs/cola-ui/cola.min.css","css");
					this.require("/static/libs/cola-ui/light7Icon.css","css");
					this.require("/static/libs/cola-ui/3rd.min.js","js");
					this.require("/static/libs/cola-ui/semantic.min.js","js");
					this.require("/static/libs/cola-ui/cola.min.js","js");
					this.require("/static/libs/cola-ui/i18n/zh/cola.min.js","js");
					break;
				case "light7"://移动端ui主框架，必须引用
					this.require("/static/libs/light7-0.4.3/css/light7.min.css","css");
					this.require("/static/css/mylight7.css","css");
					this.require("/static/libs/light7-0.4.3/js/light7.min.js","js");
					this.require("/static/libs/light7-0.4.3/js/i18n/cn.min.js","js");
					break;
				case "vue"://mvvm双向数据绑定组件
					this.require("/static/libs/vue/vue.min.js","js");
					break;
				case "swiper"://light7框架的组件之一：幻灯片
					this.require("/static/libs/light7-0.4.3/css/light7-swiper.min.css","css");
					this.require("/static/libs/light7-0.4.3/js/light7-swiper.min.js","js");
					break;
				case "cityPicker"://light7框架的组件之一：地区选择器
					this.require("/static/libs/light7-0.4.3/js/light7-city-picker.min.js","js");
					break;
				case "swipeout"://light7框架的组件之一：列表滑动删除组件
					this.require("/static/libs/light7-0.4.3/css/light7-swipeout-min.css","css");
					this.require("/static/libs/light7-0.4.3/js/light7-swipeout-min.js","js");
					break;
				case "fileupload"://文件上传组件
					this.require("/static/js/assets/fileupload.js","js");
					break;
				case "ajaxFileUpload"://文件异步上传组件
					this.require("/static/js/assets/ajaxFileUpload.js","js");
					this.require("/static/css/ajaxFileUpload.css","css");
					break;
				case "H5lock"://手势密码
					this.require("/static/libs/H5lock/H5lock.js","js");
					break;
				case "weiKeyBoard"://密码键盘
					this.require("/static/libs/weiKeyBoard/weiKeyBoard.js","js");
					this.require("/static/libs/weiKeyBoard/weiKeyBoard.css","css");
					break;
				case "carousel":
					this.require("/static/libs/carousel/carousel.js","js");
					break;
				case "fxapp":
					this.require("/static/js/assets/FXAPP-1.0.js","js");
					break;
				case "h5XhrFileUpload"://文件异步上传组件，支持多文件上传
					this.require("/static/js/assets/components/h5XhrFileUpload.js","js");
					this.require("/static/css/components/h5XhrFileUpload.css","css");
					break;
				case "layerMobile"://文件异步上传组件，支持多文件上传
					this.require("/static/libs/layer-v2.2/layer_mobile/layer.js","js");
					this.require("/static/libs/layer-v2.2/layer_mobile/need/layer.css","css");
					break;
				default: 
					try{$.alert("加载组件失败！无效的组件名！");}catch(e){alert("加载组件失败！无效的组件名！");}
			}
		},
		/**
		 * 加载指定资源
		 * @param url
		 * @param type js或css
		 */
		require : function(url,type){
			if(type == "js"){
				document.write('<script type="text/javascript" charset="utf-8" src="'+url+'"></script>');
			}else if(type == "css"){
				document.write('<link rel="stylesheet" type="text/css" href="'+url+'"></link>');
			}
		},
		/**
		 * ui加载完之后页面初始化配置入口
		 * @param fun
		 */
		ready : function(fun){
			$(document).ready(function(){
				if(typeof fun == "function"){
					try{
						fun();
					}catch(e){
						$.alert("页面初始化失败！"+e.message);
					}
				}
				$.init();//light7初始化
			});
		},
		//以下是工具类方法定义
		/**
		 * 获取平台服务地址
		 * @returns
		 */
		getPlatformContextPath : function(){
			var pathName=window.location.pathname;
			var projectName = pathName.substring(0,pathName.substring(1).indexOf('/')+1);
			var currentWwwPath=window.location.href;  
			var position=currentWwwPath.indexOf(pathName); 
			var localhostPath=currentWwwPath.substring(0,position);
			return localhostPath + "/app";
		},
		/**
		 * 获取资源服务地址
		 * @returns
		 */
		getResContextPath : function(){
			var pathName=window.location.pathname;
			var currentWwwPath=window.location.href;  
			var position=currentWwwPath.indexOf(pathName); 
			var localhostPath=currentWwwPath.substring(0,position);
			return localhostPath + "/appres";
		},
		/**
		 * 获取平台类型(01android，02ios，03微信)
		 */
		getPlatformType : function(){
			var platformType = this.parameterForURL("platformType");
			if(platformType!=undefined){
				return platformType;
			}
			var deviceIsWx = navigator.userAgent.toLowerCase().match(/MicroMessenger/i) == "micromessenger";
			var deviceIsWindowsPhone = navigator.userAgent.indexOf("Windows Phone") >= 0;
			var deviceIsAndroid = navigator.userAgent.indexOf('Android') > 0 && !deviceIsWindowsPhone;
			var deviceIsIOS = /iPhone/.test(navigator.userAgent) && !deviceIsWindowsPhone;
			if(deviceIsWx){
				return "03";
			}else if(deviceIsAndroid){
				return "01";
			}else if(deviceIsIOS){
				return "02";
			}else{
				return "01";
			}
		},
		/**
		 * post请求
		 * @param url
		 * @param data
		 * @param fun
		 * @param waitMsg
		 */
		post : function(url, param, fun, waitMsg) {
			var i;
			if(waitMsg){
				i = layer.open({type: 2,content: waitMsg});
			}
			if (param == null) {
				param = {};
			}
			param.appcsrftoken = window.localStorage.getItem('appcsrftoken');
			// 如果是跨域请求则声明发送cookie参数到服务器
			if (url.indexOf("/") != 0 && url.indexOf(this.getPlatformContextPath() + "/") == -1) {
				$.ajax({
					type : "POST",
					xhrFields : {
						withCredentials : true
					},
					crossDomain : true,
					url : url,
					async : true,
					timeout : 120000,
					data : param,
					success : function(data, textStatus, resObj) {
						var csrftoken = resObj.getResponseHeader('csrftoken');
						if (csrftoken != null && csrftoken != "") {
							window.localStorage.setItem('appcsrftoken', csrftoken);
						}
						waitMsg && layer.close(i);
						fun && fun(data);
					},
					error : function(XMLHttpRequest, textStatus, errorThrown) {
						if(waitMsg){
							layer.close(i);
						}
						layer.alert("请求出错！");
					},　
					complete : function(XMLHttpRequest,status){ //请求完成后最终执行参数
					　　　　if(status=='timeout'){//超时,status还有success,error等值的情况
					 　　　　　 ajaxTimeoutTest.abort();
					　　　　　  layer.alert("连接超时");
					　　　　}
					　　}
				});
			} else {
				$.ajax({
					type : "POST",
					url : url,
					timeout :120000,
					async : true,
					data : param,
					success : function(data, textStatus, resObj) {
						var csrftoken = resObj.getResponseHeader('csrftoken');
						if (csrftoken != null && csrftoken != "") {
							window.localStorage.setItem('appcsrftoken', csrftoken);
						}
						waitMsg && layer.close(i);
						fun && fun(data);
					},
					error : function(XMLHttpRequest, textStatus, errorThrown) {
						waitMsg && layer.close(i);
						layer.alert("请求出错！");
					},
					complete : function(XMLHttpRequest,status){ //请求完成后最终执行参数
					　　　　if(status=='timeout'){//超时,status还有success,error等值的情况
					 　　　　　 ajaxTimeoutTest.abort();
					　　　　　  layer.alert("超时");
					　　　　}
					　　}
				});
			}
		},
		/**
		 * 添加*
		 */
		hideSecretContent:function(number,type){
        	if(number != null && number != ""){
        		var x = number.length;
        		var a,b,c;
        		if(type == "sjhm"){
        			a = 3;
        			c = 4;
        			b = x - a - c;
        		} else if(type == "xm"){
        			a = 0;
        			c = 1;
        			b = x - a - c;
        		} else if(type == "201"){
        			a = 6;
        			c = 4;
        			b = x - a - c;
        		}else{
        			if(x%4 == 0){
        				a = x/4;
        				b = x/2;
        				c = x/4;
        			}else if(x%2 == 0 && x%4 != 0){
        				a = parseInt(x/4);
        				b = x/2;
        				c = parseInt(x/4)+1;
        			}else if(x%2 != 0){
        				a = parseInt((x-parseInt(x/2))/2);
        				b = parseInt(x/2);
        				c = x-parseInt(x/2)-parseInt((x-parseInt(x/2))/2);
        			}
        		}
        		var mod = "";
        		for(var k=0;k<b;k++){
        			mod = mod + "*";
        		}
        		return number.substring(0,a)+mod+number.substring(x-c,x);
        	}else{
        		return number;
        	}
        },
		
		
		/**
		 * get请求，如果运行在原生app内部，则调用原生方法发请求，否则用jquery
		 * @param url
		 * @param fun
		 * @param waitMsg
		 */
		get : function(url,fun,waitMsg){
			if(waitMsg){
				//$.showPreloader(waitMsg);
			}
			if(typeof(FXAPP)!="undefined" && FXAPP.isApp() && typeof(FXAPP.post) == "function"){
				var param = {};
				param.url = url;
				var fail = function(errMsg){
					if(waitMsg){
						//$.hidePreloader();
					}
					//$.alert(errMsg);
				}
				var success = function(d){
					if(waitMsg){
						//$.hidePreloader();
					}
					if(typeof(fun) == "function"){
						fun(d);
					}
				}
				FXAPP.get(param,success,fail);
			}else{
				$.get(url,function(d){
					if(waitMsg){
						//$.hidePreloader();
					}
					if(typeof(fun) == "function"){
						fun(d);
					}
				});
			}
		},
		/**
		 * 从url中获取指定参数
		 */
		parameterForURL : function (name) {
			var url = window.location.href;
			var p = -1;
			var value = undefined;
			if (((p = Math.max(url.indexOf("&" + name + "="), url.indexOf("?" + name
					+ "="))) > -1)) {
				value = url.substring(p + name.length + 2);
				if (value.indexOf("&") > -1) {
					value = value.substring(0, value.indexOf("&"));
				} else if (value.indexOf("#") > -1) {
					value = value.substring(0, value.indexOf("#"));
				}
			}
			return value;
		},
		/**
		 * 从localStorage和url中获取参数值
		 */
		parameterForLSAndURL : function (LSkey,URLname) {
			var value = undefined;
			if(LSkey!=null){
                value = localStorage.getItem(LSkey);
			}
			if(value===""||value==null||typeof(value)==="undefined"){
				if(URLname!=null&&URLname!=""){
					value = this.parameterForURL(URLname);
				}else{
					value = undefined;
				}
			}
			return value==undefined?null:value;
		},
		/**
		 * 增加页脚
		 */
		addFooter : function(){
			var footer = '<nav class="bar bar-tab" style="font-size:0.6rem;">'
						+'<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="0"><tr><td align="right"><img src="/static/images/common/fxlogo.png" style="margin:0.2rem;width:1rem;display:block;"/></td><td align="left">方欣移动办税&nbsp;-&nbsp;客服电话：020-62847100</td></tr></table>'
						+'</nav>';
			//$(document.body).prepend(footer);
		},
		/**
		 * 跳转到指定页面
		 * @param page
		 */
		goPage : function (page){
			//$.showIndicator();
		    setTimeout(function () {
		        window.location.href = page;
		    }, 100);
		    setTimeout(function () {
		       // $.hideIndicator();
		    }, 100);
		},
		/**
		 * 跳转到指定页面（如果原页面有指定返回页面，则跳到该返回页面）
		 * @param page
		 */
		goPageIfRedirect : function (page,redirectParam){
			//$.showIndicator();
            if(!redirectParam)redirectParam='redirectUrl';
            var redirectUrl = this.parameterForURL(redirectParam);
		    setTimeout(function () {
		    	if(redirectUrl) {
                    top.location.href = decodeURIComponent(redirectUrl);
				}else {
		        	window.location.href = page;
				}
		    }, 100);
		    setTimeout(function () {
		        $.hideIndicator();
		    }, 3000);
		},
		/**
		 * 跳转到指定页面(如果页面有指定返回页面，则将返回页面url附带到下一页面）
		 * @param page
		 */
		goPageWithRedirect : function (page,redirectParam){
			//$.showIndicator();
			if(!redirectParam)redirectParam='redirectUrl';
			var redirectUrl = this.parameterForURL(redirectParam);
		    setTimeout(function () {
		    	if(page.indexOf("?") >= 0 && page.indexOf(redirectParam+"=") <0 && redirectUrl) {
		    		page += "&" + redirectParam + "=" + redirectUrl;
				}else if(page.indexOf("?") < 0 && page.indexOf(redirectParam+"=") <0 && redirectUrl) {
                    page += "?" + redirectParam + "=" + redirectUrl;
				}
		        window.location.href = page;
		    }, 100);
		    setTimeout(function () {
		        $.hideIndicator();
		    }, 3000);
		},
		//以下是业务相关方法
		/**
		 * 把当前用户会话信息推送到局端计入点
		 * @param fun 推送完成的回调函数
		 * @param serverId 接入点id，如果不传则默认推送到当前应用的默认接入点
		 * @param gdslx 需要推送到接入点的国税服务还是地税服务
		 * @param waitMsg
		 */
		pushSessionToBizfront : function(fun,serverId,gdslx,waitMsg){
			var that = this;
			this.post(this.getPlatformContextPath()+"/user/getServerUrlAndUserMd5.do",{serverId:serverId,gdslx:gdslx}, function(d){
				if(d.flag == "error"){
					$.alert(d.errMsg);
				}else{
					var userMd5 = d.userMd5;
					var serverUrl = d.serverUrl;
					//请求局端接入点检查是否需要推送会话
					that.post(serverUrl+"/session/checkSession.do",{userMd5:userMd5},function(d){
						var redisSessionCookieName = d.redisSessionCookieName;
						var appfrontSessionId = d.appfrontSessionId;
						if(d.flag == "setSession"){//需要推送会话
							that.post(that.getPlatformContextPath()+"/user/setAppfrontSession.do", {serverId:serverId,appfrontSessionId:appfrontSessionId,gdslx:gdslx}, function(d){
								fun && fun(true,serverId,redisSessionCookieName,appfrontSessionId);
							}, waitMsg);
						}else{
							fun && fun(false,serverId);
						}
					});
				}
			}, waitMsg)
		},
		/**
		 * 检查用户是否有登录
		 * @param isGotoLoginPage 没登录的时候是否要跳转到登录页 
		 * @param fun 回调
		 */
		checkIsLogin : function(isGotoLoginPage,fun){
			var that = this;
			this.post(this.getPlatformContextPath()+"/user/getAppUserDetails.do",{},function(d){
				if(d.userDetails == null && isGotoLoginPage){
					cola.alert("请先登录！",function(){
						that.goPage(that.getPlatformContextPath()+"/assets/user/login.html");
					});
				}else{
					if(typeof(fun) == "function"){
						fun(d.userDetails,d.isUserChange,d.currentApp,d.currentServer);
					}
				}
			},"请稍候...");
		},
		/**
		 * 把当前页面的title设置为应用名称
		 */
		setPageTitle : function(){
			this.post(this.getPlatformContextPath()+"/user/getAppUserDetails.do",{},function(d){
				$("title").html(d.currentApp.name);
			});
		},
        /**
         * 微信配置设置
         */
        wxConfig:function (wxReady) {
            //初始化微信jssdk配置
            var localUrl = window.location.href.split('#')[0];
            var param = {url:localUrl};
            this.post(this.getPlatformContextPath(true)+"/wx/getJsSdkConfig.do",param,function(d){
                wx.config({
                    debug : false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
                    appId : d.appId, // 必填，公众号的唯一标识
                    timestamp : d.timestamp, // 必填，生成签名的时间戳
                    nonceStr : d.nonceStr, // 必填，生成签名的随机串
                    signature : d.signature,// 必填，签名，见附录1
                    jsApiList : ["onMenuShareTimeline", "onMenuShareAppMessage",
                        "onMenuShareQQ", "onMenuShareWeibo", "startRecord",
                        "stopRecord", "onVoiceRecordEnd", "playVoice",
                        "pauseVoice", "stopVoice", "onVoicePlayEnd",
                        "uploadVoice", "downloadVoice", "chooseImage",
                        "previewImage", "uploadImage", "downloadImage",
                        "translateVoice", "getNetworkType", "openLocation",
                        "getLocation", "hideOptionMenu", "showOptionMenu",
                        "hideMenuItems", "showMenuItems",
                        "hideAllNonBaseMenuItem", "showAllNonBaseMenuItem",
                        "closeWindow", "scanQRCode", "chooseWXPay",
                        "openProductSpecificView", "addCard", "chooseCard",
                        "openCard"]// 必填，需要使用的JS接口列表，所有JS接口列表见附录2
                });
                wx.ready(function() {
                	this.IsWxConfig = true;
                    if (typeof (wxReady) == "function") {
                        wxReady();
                    }
                });
            });
        },
		scanQRcode:function (params, success, fail) {
            //若要使用FXAPP 请在页面上加入FXUI.requireComponent("fxapp");
        	if(FXAPP && FXAPP.isApp()) {
                FXAPP.scanQRCode(params, success, fail);
			}else {
        		var func = function () {
                    wx.scanQRCode({
                        needResult: 1, // 默认为0，扫描结果由微信处理，1则直接返回扫描结果，
                        scanType: ["qrCode","barCode"], // 可以指定扫二维码还是一维码，默认二者都有
                        success: function (res) {
                            var result = res.resultStr; // 当needResult 为 1 时，扫码返回的结果
                            if(typeof (success) == "function") {
                                success(result);
                            }
                        }
                    });
                }
        		if(!this.IsWxConfig) {
        			this.wxConfig(func);
				}else {
        			func();
				}

			}
        }
	}
	window.FXUI = new FXUI();
	document.write("<style>body{position:relative;}</style>");
})($);