#$.each(elements,callback)

```

Iterates through elements and executes a callback.  Returns if false
        
```

##Example

```
        $.each([1,2],function(ind){console.log(ind);});
        
```


##Parameters

```
elements                      Array|Object
callback                      Function

```

##Returns

```
Array                         elements
```

##Detail

$.each allows you to iterate through a collection and execute a callback.  Does not have to be DOM nodes.

The callback recieves two parameters, the index of the element (or key in an object) and then the element

Below is a simple function that will iterate through an array and add the values to the "sum" variable.
```
function getSum(arr){
	var sum=0;
	$.each(arr,function(index,val){sum+=val});
	return sum;
}
alert(getSum([1,2,3,4]));
```