!function() {
	function loadCss(css, _document) {
		if (!css) {
			return;
		}
		if (Object.prototype.toString.call(css) !== '[object Array]') {
			css = [ css ];
		}
		if (typeof _document === 'undefined') {
			_document = document;
		}
		for (var i = 0; i < css.length; i++) {
			if (_document.querySelector('link[href="' + css[i] + '"]')) {
				continue;
			}
			var link = _document.createElement('link');
			link.type = 'text/css';
			link.rel = 'stylesheet';
			link.href = css[i];
			appendToHead(_document, link);
		}
	}

	function loadScript(script, _document, callback) {
		if (!script) {
			return;
		}
		if (Object.prototype.toString.call(script) !== '[object Array]') {
			script = [ script ];
		}
		if (typeof _document === 'undefined') {
			_document = document;
		}
		if (typeof _document === 'function') {
			callback = _document;
			_document = document;
		}
		var index = 0;
		var appendScript = function() {
			if (index >= script.length) {
				if (typeof callback === 'function') {
					setTimeout(function() {
						callback();
					}, 500);
				}
				return;
			}
			var url = script[index++];
			if (!url || _document.querySelector('script[src="' + url + '"]')) {
				appendScript();
				return;
			}
			var _script = _document.createElement('script');
			_script.type = 'text/javascript';
			_script.src = url;
			appendToHead(_document, _script);
			if (_script.readyState) {
				_script.onreadystatechange = function() {
					if (_script.readyState === 'loaded'
							|| _script.readyState === 'complete') {
						_script.onreadystatechange = null;
						appendScript();
					}
				}
			} else {
				_script.onload = function() {
					appendScript();
				}
				_script.onerror = function() {
					appendScript();
				}
			}
		};
		appendScript();
	}

	function appendToHead(_document, element) {
		var head = _document.getElementsByTagName('head');
		(head && head.length > 0) && head[0].appendChild(element);
	}

	function loadScript2(script, _document, callback) {
		if (!script) {
			return;
		}
		if (Object.prototype.toString.call(script) !== '[object Array]') {
			script = [ script ];
		}
		if (typeof _document === 'undefined') {
			_document = document;
		}
		if (typeof _document === 'function') {
			callback = _document;
			_document = document;
		}
		var index = 0;
		var appendScript = function() {
			if (index >= script.length) {
				if (typeof callback === 'function') {
					callback();
				}
				return;
			}
			var url = script[index++];
			var success = function(content) {
				appendToHead2(_document, content);
				appendScript();
			};
			var error = function() {
				console.error('Load failed: ' + url);
				appendScript();
			};
			var request;
			var method = 'GET';
			var complete = function() {
				request.status == 200 ? success(request.responseText) : error();
			};
			request = new XMLHttpRequest;
			request.open(method, url, false);
			request.onload = complete;
			request.onerror = error;
			request.ontimeout = error;
			request.send();
		};
		appendScript();
	}

	function appendToHead2(_document, scriptText) {
		var head = _document.getElementsByTagName('head')[0];
		var script = _document.createElement('script');
		script.appendChild(_document.createTextNode(scriptText));
		head && head.appendChild(script);
	}

	window.loadCss = loadCss;
	window.loadScript = loadScript;
	window.loadScript2 = loadScript2;
}();
